<template>
    <div>
        <h2>Create Journal</h2>

        <form @submit.prevent="createJournal">
            <div class="form-group">
                <label for="date">Date</label>
                <input type="date" id="date" v-model="journal.date" required />
            </div>

            <div class="form-group">
                <label for="journal">Journal</label>
                <textarea
                    id="journal"
                    v-model="journal.journal"
                    required
                ></textarea>
            </div>

            <div class="form-group">
                <button type="submit" class="btn btn-primary">Create</button>
            </div>

            <div v-if="errors.length" class="alert alert-danger">
                <ul>
                    <li v-for="error in errors" :key="error">{{ error }}</li>
                </ul>
            </div>
        </form>
    </div>
</template>

<script>
import axios from 'axios';

export default {
    name: 'JournalForm',
    props: {
        clientId: {
            required: true,
        },
    },
    data() {
        return {
            journal: {
                date: '',
                journal: '',
                client_id: this.clientId,
            },
            errors: [],
        };
    },
    methods: {
        createJournal() {
            axios
                .post(`/clients/${this.clientId}/journals`, this.journal)
                .then((response) => {
                    this.$emit('journal-created', response.data);
                })
                .catch((error) => {
                    if (error.response.status === 422) {
                        this.errors = Object.values(
                            error.response.data.errors
                        ).flat();
                    } else {
                        this.errors = ['Something went wrong.'];
                    }
                });
        },
    },
};
</script>
